{kml.googleearth.detailed.gge.pas
v1.0
Medwyn_cz (medwyn@seznam.cz)}
{$INCLUDE kml.library.pas }

const
  //adresa ke slozce ikon
  imgloc = 'http://geoget.ararat.cz/img/kmlexport_icons';
  //jmeno slozky s malymi ikonami
  smallFolder = 'small';
  //jmeno slozky s velkymi ikonami
  largeFolder = 'large';
  //jmeno slozky s malymi disabled ikonami
  disabled = 'disabled';
  //ma vystup obsahovat listing?
  IncludeListing = false;


function ExportDescription: string;
begin
  result := 'KML - Google Earth (Details)';
end;

{Metoda vraci cestu k velke ci male ikone (podle predaneho parametru). Pokud se
jedna o malou ikonu, podle aktualniho stavu cache spravne vrati enabled ci disabled
verzi}
function GetIconFolder(Size: String) : String;
begin
Result := imgloc + '/';
if Size = 'l' then
  begin
    Result := Result + 'large' + '/';
  end
else if Size = 's' then
  begin
    Result := Result + 'small' + '/';
    if GC.IsDisabled then Result := Result + disabled + '/';
  end
else Result := '';
end;


function ExportPoint: string;
var
  name: string;
  description: string;
  sUrl: string;
  lUrl: string;
  n: integer;
begin
  //export pro geocache
  if GC.IsListed then
  begin
    //nejprve poskladame parametry.. 
    name := GC.Name;
    sUrl := GetIconFolder('s') + GC.CacheType + '.png'; //soubory s obrazky pojmenovane stejne jako typ cache
    lUrl := ReplaceSpaces(GetIconFolder('l') + GC.CacheType + '.png');
    if GC.IsFound then sUrl := GetIconFolder('s') + 'Found.png';
    if GC.IsOwner then sUrl := GetIconFolder('s') + 'Own.png';
    description := '<img src="' + lUrl + '">';
    if GC.IsFound then description := description + '<img src="' + GetIconFolder('l') + 'Found.png">';
    if GC.IsDisabled then description := description + '<br><div style="color:red">Cache is disabled</div>';
    description := description + '<br>' + 
    +  '<b>Waypoint: </b><a href="' + GC.url + '">' + GC.ID + '</a><br>'
    +  '<b>Author: </b>' + GC.Author + '<br>'
    +  '<b>Cache type: </b>' + GC.CacheType + '<br>'
    +  '<b>Container: </b>' + GC.Size + '<br>'  
    +  '<b>Difficulty: </b>' + GC.Difficulty + '<br>' 
    +  '<b>Terrain: </b>' + GC.Terrain + '<br>' 
    +  '<b>Coordinates: </b>' + GC.Lat + ', ' + GC.Lon + '<br>' 
    +  '<b>Date hidden: </b>' + formatdatetime('dd"-"mm"-"yyyy', GC.Hidden) + '<br>' 
    +  '<b>Last found: </b>' + formatdatetime('dd"-"mm"-"yyyy', GC.LastFound) + '<br>' 
    +  '<b>Last updated: </b>' + formatdatetime('dd"-"mm"-"yyyy', GC.Updated) + '<br><br>';
    if IncludeListing then description := description + GC.ShortDescription + '<br><br>' + GC.LongDescription;
    //.. a potom nechame logiku kml.library bod zpracovat
    ProcessPoint(GC.CacheType,name,description,sUrl,GC.Lat,GC.Lon);
  end;
  //export pro waypointy
  for n := 0 to GC.Waypoints.Count - 1 do
  begin
    if GC.Waypoints[n].isListed then
    begin
      //nejprve poskladame parametry.. 
      name := GC.Name + ' [' + GC.Waypoints[n].Name + ']';
      sUrl := GetIconFolder('s') + '/Waypoint.png';
      description := '';
      if GC.IsDisabled then description := '<div style="color:red">Cache is disabled</div><br>';
      description := description +
      +  '<b>Waypoint: </b><a href="' + GC.url + '">' + GC.Waypoints[n].ID + '</a><br>'
      +  '<b>Author: </b>' + GC.Author + '<br>'
      +  '<b>Waypoint type: </b>' + GC.Waypoints[n].WptType + '<br>'
      +  '<b>Name: </b>' + GC.Waypoints[n].Name + '<br>'
      +  '<b>Description: </b>' + GC.Waypoints[n].Description + '<br>'
      +  '<b>Parent: </b>' + GC.Name + '<br>'
      +  '<b>Coordinates: </b>' + GC.Waypoints[n].Lat + ', ' + GC.Waypoints[n].Lon + '<br>';
      //.. a potom nechame logiku kml.library bod zpracovat
      ProcessPoint('Waypoint',name,description,sUrl,GC.Waypoints[n].Lat,GC.Waypoints[n].Lon);
    end
  end;
  Result := '';
end;

{Po skonceni se snazime otevrit tento soubor. Pokud je nainstalovany GGE, otevre se}
function ExportAfter(value: string) : string;
begin
  RunShell(value);
end;